/*
   Program....: Explode.Prg
   System.....: MARVY50.Lib  -  Clipper 5.01 Version
   Author.....: Michael Clerc
   Date.......: Fri  03-05-1993  14:01:27
   Purpose....: To Simulate an E-X-P-L-O-D-I-N-G Box
              :
   Syntax.....: Explode(nTop, nLeft, nBottom, nRight, nSpeed, cColor, nStyle, cName)
              : nTop    = the top row
              : nLeft   = the left column
              : nBottom = the bottom row
              : nRight  = the right hand column
              : nSpeed  = the explosion speed
              : cColor  = the color of the box and border
              : nStyle  = the box border style... explained in the documentation
              : cName   = the name of the box... used for Implode()
              :
   Copyright..:           Simply Marvelous Solutions
                                 Mesa, AZ
                       (c) 1993 - All Rights Reserved
*/
Function Explode
Parameters nTop, nLeft, nBottom, nRight, nDelay, cColor, nStyle, cName
Local nSeed1, nSeed2, nBlowt1, nBlowt2, nBlowt3, nBlowt4, nCount1, lSave, ;
 nCount2

nSeed1    = Int(( nBottom - nTop ) / 2)
nSeed2    = Int(( nRight - nLeft ) / 2)
nBlowt1   = nTop  + nSeed1
nBlowt2   = nLeft + nSeed2
nBlowt3   = nBlowt1
nBlowt4   = nBlowt2
SetColor( cColor )

If PCount() = 8
  Public &cName.[20]
  Afill(&cName.,"")
  &cName.[20] := nTop
  &cName.[19] := nLeft
  &cName.[18] := nBottom
  &cName.[17] := nRight
  &cName.[1]  := SaveScreen( nTop, nLeft, nBottom + 2, nRight + 2 )
  nCount2     := 2
  lSave := .T.
Else
  lSave := .F.
Endif

If nDelay > 1
  Do While (nBlowt1 > nTop .and. nBlowt2 > nLeft) .and. ;
   (nBlowt3 < nBottom .and. nBlowt4 < nRight)

    If Type("nStyle") = "C"
      @nBlowt1, nBlowt2, nBlowt3, nBlowt4 Box Replicate(nStyle,9)
    ElseIf Type("nStyle") = "N"
      @nBlowt1, nBlowt2, nBlowt3, nBlowt4 Box TypeBox(nStyle)
    Endif

    If lSave
      &cName.[nCount2] = SaveScreen(nTop, nLeft, nBottom + 2, nRight + 2)
      nCount2++
    Endif

    For nCount1 := 1 to nDelay
    Next

    nBlowt1--     // = nBlowt1 - 1
    nBlowt2 = nBlowt2 - (nSeed2 / nSeed1)
    nBlowt3++     // = nBlowt3 + 1
    nBlowt4 = nBlowt4 + (nSeed2 / nSeed1)
  Enddo
Endif

** and now for the shadows
** this is the side
ChgAttr(nBottom, nLeft + 2, nBottom + 1, nRight + If(nRight = 78, 1, 2), 8, 0)
** this is the bottom
ChgAttr(nTop + 1, nRight + 1, nBottom + 1, nRight + If(nRight = 78, 1, 2), 8, 0)

If Type("nStyle") = "C"
  @nTop, nLeft, nBottom, nRight Box Replicate( nStyle, 9 )
ElseIf Type("nStyle") = "N"
  @nTop, nLeft, nBottom, nRight Box TypeBox( nStyle )
Endif
Return( NIL )
** Eof........: Explode.Prg

/*
   Program....: Implode.Prg
   System.....: MARVY50.Lib  -  Clipper 5.01 Version
   Author.....: Michael Clerc
   Date.......: Mon  11-04-1991   09:25:04
   Purpose....: to IMPLODE an E-X-P-L-O-D-E-D Box
              :
   Syntax.....: Implode( cName, [ nSpeed ] )
              : cName   = the name of the box to be IMPLODED
              : nSpeed  = the Implosion speed  ** OPTIONAL **
              :
   Copyright..:           Simply Marvelous Solutions
                             Fountain Valley, CA
                       (c) 1992 - All Rights Reserved
*/
Function Implode
Parameters cName, nDelay
Local nStepper, nCount2, nStep := 16

** check to make sure that it was saved, and or NOT released...
If Type("cName") = "U"
  Return( NIL )
Endif

** if a delay was NOT specified, make one...
If Type("nDelay") = "U"
  nDelay := 25
Endif

nStep = 16

For nStepper := 1 to 16
  If Len(&cName.[nStep]) > 0
    RestScreen(&cName.[20], &cName.[19], &cName.[18] + 2, &cName.[17] +;
      2,&cName.[nStep])
    For nCount2 = 1 to nDelay
    Next
  Endif
  nStep--
Next

Release &cName.
Return( NIL )
*** Eof.......: Implode.Prg
